open Filename
open Arg
open Printf


let (do_simplify, src) =
  let do_simplify = ref true and src = ref "" in
  let usage = "Usage: compile [--no-simplify] file" in
  let spec = [ "--no-simplify", Clear do_simplify, "Disable push/pop optimization" ] in
  let read x =
    if !src = "" then
      src := x
    else
      raise (Bad (sprintf "I don't know what to do with %s" x))
  in parse spec read usage;
  (!do_simplify, !src)


let () =
  let dst = if check_suffix src ".ml" then chop_suffix src ".ml" else src in
  let gcc_command = sprintf "gcc -o %s.out %s.ml.s" dst dst in
  let prog = Projet.parse src in
  Typeur.type_prog prog;
  Translate.output_file do_simplify (dst ^ ".ml.s") prog;
  printf "Calling \"%s\"...\n" gcc_command;
  exit (Sys.command gcc_command)
